// Generated by CoffeeScript 2.4.1
(function() {
  var CouchDB, Nimble, SIPSender, User, ccnq4_receiver, ccnq4_resolve, debug, dgram, foot, get_prov, message_summary, pkg, send_notification_to, sender, socket, trace;

  dgram = require('dgram');

  pkg = require('../package.json');

  this.name = `${pkg.name}:middleware:mwi_notifier`;

  ({debug, foot} = (require('tangible'))(this.name));

  trace = function() {};

  User = require('../src/User');

  CouchDB = require('most-couchdb');

  Nimble = require('nimble-direction');

  send_notification_to = null;

  this.include = function() {
    var base, base1;
    if ((base = this.cfg).notifiers == null) {
      base.notifiers = {};
    }
    if ((base1 = this.cfg.notifiers).mwi == null) {
      base1.mwi = send_notification_to;
    }
    return null;
  };

  get_prov = require('five-toes/get-prov');

  message_summary = require('five-toes/message-summary');

  ccnq4_resolve = require('five-toes/ccnq4-resolve');

  ccnq4_receiver = require('five-toes/ccnq4-receiver');

  SIPSender = require('five-toes/sip-sender');

  socket = dgram.createSocket('udp4');

  sender = new SIPSender(socket);

  this.end = function() {
    return socket.close();
  };

  this.server_pre = function(ctx) {
    var cfg, prov, receive, ref, ref1, resolve;
    cfg = Nimble(ctx.cfg);
    debug('server_pre');
    prov = new CouchDB(cfg.provisioning);
    receive = ccnq4_receiver(cfg);
    resolve = ccnq4_resolve(cfg);
    receive(socket, async function({user_id}) {
      var db_uri, error, ref, request, user, user_database;
      // Recover the local-number's user-database.
      ({user_database} = (await get_prov(prov, `number:${user_id}`)));
      // Ready to send a notification
      db_uri = cfg.userdb_base_uri + '/' + user_database;
      trace('SUBSCRIBE', {user_database, db_uri});
      if (user_database == null) {
        return;
      }
      request = null;
      // Create a User object and use it to send the notification.
      user = new User(ctx, user_id, user_database, db_uri);
      try {
        await send_notification_to(user);
      } catch (error1) {
        error = error1;
        debug(`SUBSCRIBE send_notification_to: ${(ref = error.stack) != null ? ref : error}`, user_id);
      } finally {
        await user.close_db();
        user = null;
      }
      debug("SUBSCRIBE done");
    });
    // Start socket
    // ------------

    // * cfg.voicemail.notifier_port (integer) Port number for the (UDP) forwarding of SUBSCRIBE messages for voicemail notifications.
    socket.bind((ref = (ref1 = cfg.voicemail) != null ? ref1.notifier_port : void 0) != null ? ref : 7124);
    // Notifier Callback: Send notification to a user
    // ==============================================
    send_notification_to = async function(user) {
      var content, dest, new_messages, rows, saved_messages;
      trace('send_notification_to', user.id);
      // Collect the number of messages from the user's database.
      rows = (await user.get_new_messages());
      new_messages = rows.length;
      rows = (await user.get_saved_messages());
      saved_messages = rows.length;
      trace('send_notification_to', {new_messages, saved_messages});
      content = message_summary(new_messages, saved_messages);
      // Collect the endpoint/via fields from the local number.
      dest = (await resolve(user.id));
      // * doc.local_number.endpoint_via (domain name string) If present, domain name used to route voicemail notifications via the SUBSCRIBE/PUBLISH mechanism. It is optional for dynamic endpoints (`<username>@<endpoint-domain>`) and required for static endpoints. Default: the domain of doc.local_number.endpoint (for dynamic endpoints), none for static endpoints.
      // * doc.local_number.endpoint (endpoint name string) If `<username>@<endpoint-domain>`, used for routing voicemail notifications va the SUBSCRIBE/PUBLISH mechanism, unless doc.local_number.endpoint_via is specified. If `<endpoint-domain>` (for static endpoints), domain name used as destination for voicemail notifications, while routing is done using the doc.local_number.endpoint_via domain name.
      await sender.publish(dest, content);
      trace('send_notification_to: done', user.id);
    };
    debug('Configured.');
  };

}).call(this);
