// Generated by CoffeeScript 2.4.1
(function() {
  // This is the ccnq4 voicemail server.

  // `mod_httapi` is used to record or play
  // files to/from remote CouchDB. (This avoids having to download
  // audio prompts, or store then upload recorded messages.)

  // Voicemail content is stored as .wav PCM mono 16 bits (generated
  // by FreeSwitch) which can then be transcoded.
  // (RIFF (little-endian) data, WAVE audio, Microsoft PCM, 16 bit, mono 8000 Hz)
  var Message, Messaging, close_delay, debug, finish, pkg, seconds;

  Messaging = require('../src/Messaging');

  Message = require('../src/Message');

  seconds = 1000;

  pkg = require('../package.json');

  this.name = `${pkg.name}:middleware:voicemail`;

  ({debug} = (require('tangible'))(this.name));

  // `esl` will wait 4000ms, while our own `Message` will wait 3000ms.
  // In any case closing too early will cause issues with email notifications.
  close_delay = 60 * seconds;

  finish = function(user) {
    var handler;
    debug('finish');
    handler = async function() {
      debug('finish - closing db');
      try {
        await (user != null ? user.close_db() : void 0);
      } catch (error1) {}
      return user = null;
    };
    return setTimeout(handler, close_delay);
  };

  this.include = async function() {
    var do_recording, error, messaging, msg, ref, ref1, ref2, ref3, rows, user;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'voicemail') {
      return;
    }
    messaging = new Messaging(this);
    debug(`Routing incoming call to ${this.destination}`);
    switch (this.destination) {
      case 'inbox':
        try {
          await this.action('answer');
          if (this.session == null) {
            return;
          }
          await this.set({
            language: (ref1 = this.session.language) != null ? ref1 : this.cfg.announcement_language
          });
          debug('Locate user', this.source);
          user = (await messaging.locate_user(this.source));
          debug('Authenticate', user);
          await user.authenticate();
          debug('Enumerate messages');
          rows = (await user.new_messages());
          await user.navigate_messages(rows, 0);
          debug('Go to the main menu after message navigation');
          await user.main_menu();
        } catch (error1) {
          error = error1;
          debug.error('inbox', error);
        } finally {
          finish(user);
          user = null;
          rows = null;
        }
        break;
      case 'main':
        try {
          await this.action('answer');
          if (this.session == null) {
            return;
          }
          await this.set({
            language: (ref2 = this.session.language) != null ? ref2 : this.cfg.announcement_language
          });
          debug('Retrieve and locate user');
          user = (await messaging.gather_user());
          debug('Authenticate', user.id);
          await user.authenticate();
          debug('Present the main menu');
          await user.main_menu();
        } catch (error1) {
          error = error1;
          debug.error('main', error);
        } finally {
          finish(user);
          user = null;
        }
        break;
      default:
        try {
          await this.action('answer');
          if (this.session == null) {
            return;
          }
          await this.set({
            language: (ref3 = this.session.language) != null ? ref3 : this.cfg.announcement_language
          });
          debug('Locate user', this.destination);
          user = (await messaging.locate_user(this.destination));
          msg = new Message(this, user);
          await msg.create();
          do_recording = (await user.play_prompt());
          if (do_recording) {
            await msg.start_recording();
            await msg.post_recording();
          }
          await this.prompt.goodbye();
        } catch (error1) {
          error = error1;
          debug.error('default', error);
        } finally {
          finish(user);
          user = null;
          msg = null;
        }
    }
    messaging = null;
    debug('Done.');
  };

}).call(this);
